//Future releases will allow adding of addional morphs, and saving settings... still gotta figua those out.

using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace AWWalker
{
    public class GenitalMultiPass : MVRScript
    {
        private static FreeControllerV3 chest;
        private static FreeControllerV3 lKnee;
        private static FreeControllerV3 rKnee;



        private bool rightSide = false;
        private bool leftSide = true;


        private JSONStorableString jstr_Hood;
        private JSONStorableString jstr_Majora;

        private DAZMorph HoodModMorph;
        protected JSONStorableFloat HoodModMorphChangeMin;
        protected JSONStorableFloat HoodModMorphChangeMax;

        private DAZMorph labiaMajoraMorph;
        protected JSONStorableFloat labiaMajoraMorphChangeMin;
        protected JSONStorableFloat labiaMajoraMorphChangeMax;

        private DAZMorph LabMajRMidMorph;
        protected JSONStorableFloat LabMajRMidMorphChangeMin;
        protected JSONStorableFloat LabMajRMidMorphChangeMax;

        private DAZMorph LabMajLUpMorph;
        protected JSONStorableFloat LabMajLUpMorphChangeMin;
        protected JSONStorableFloat LabMajLUpMorphChangeMax;

        private DAZMorph LabMajLMidMorph;
        protected JSONStorableFloat LabMajLMidMorphChangeMin;
        protected JSONStorableFloat LabMajLMidMorphChangeMax;

        private DAZMorph LabMajLLowMorph;
        protected JSONStorableFloat LabMajLLowMorphChangeMin;
        protected JSONStorableFloat LabMajLLowMorphChangeMax;

        private DAZMorph LabMinRMidMorph;
        protected JSONStorableFloat LabMinRMidMorphChangeMin;
        protected JSONStorableFloat LabMinRMidMorphChangeMax;

        private DAZMorph LabMinRUpMorph;
        protected JSONStorableFloat LabMinRUpMorphChangeMin;
        protected JSONStorableFloat LabMinRUpMorphChangeMax;

        private DAZMorph LabMinLLowMorph;
        protected JSONStorableFloat LabMinLLowMorphChangeMin;
        protected JSONStorableFloat LabMinLLowMorphChangeMax;

        private DAZMorph LabMinLUpMorph;
        protected JSONStorableFloat LabMinLUpMorphChangeMin;
        protected JSONStorableFloat LabMinLUpMorphChangeMax;

        private DAZMorph LabMajRLowMorph;
        protected JSONStorableFloat LabMajRLowMorphChangeMin;
        protected JSONStorableFloat LabMajRLowMorphChangeMax;

        private DAZMorph LabMinRLowMorph;
        protected JSONStorableFloat LabMinRLowMorphChangeMin;
        protected JSONStorableFloat LabMinRLowMorphChangeMax;

        private DAZMorph LabMajRUpMorph;
        protected JSONStorableFloat LabMajRUpMorphChangeMin;
        protected JSONStorableFloat LabMajRUpMorphChangeMax;

        private DAZMorph LabMinLMidMorph;
        protected JSONStorableFloat LabMinLMidMorphChangeMin;
        protected JSONStorableFloat LabMinLMidMorphChangeMax;

        private DAZMorph labiaMinoraMorph;
        protected JSONStorableFloat labiaMinoraMorphChangeMin;
        protected JSONStorableFloat labiaMinoraMorphChangeMax;


        private DAZMorph AWW_Majora_LeftUpperTopMorph;
        protected JSONStorableFloat AWW_Majora_LeftUpperTopMorphChangeMin;
        protected JSONStorableFloat AWW_Majora_LeftUpperTopMorphChangeMax;

        private DAZMorph AWW_Majora_RightUpperTopMorph;
        protected JSONStorableFloat AWW_Majora_RightUpperTopMorphChangeMin;
        protected JSONStorableFloat AWW_Majora_RightUpperTopMorphChangeMax;

        private DAZMorph AWW_VagInternal_Size2;
        protected JSONStorableFloat AWW_VagInternal_Size2ChangeMin;
        protected JSONStorableFloat AWW_VagInternal_Size2ChangeMax;

        private DAZMorph AWW_Clitoris_Front_Back;
        protected JSONStorableFloat AWW_Clitoris_Front_BackMin;
        protected JSONStorableFloat AWW_Clitoris_Front_BackMax;

        private DAZMorph AWW_Clitoris_HoodBack;
        protected JSONStorableFloat AWW_Clitoris_HoodBackMax;

        private DAZMorph AWW_Clitoris_Size;
        protected JSONStorableFloat AWW_Clitoris_SizeMax;

        private DAZMorph AWW_Clitoris_HoodSize;
        protected JSONStorableFloat AWW_Clitoris_HoodSizeMax;


        protected JSONStorableFloat OverallIntensity;

        private float Remap(float inVal, float min1, float max1, float min2, float max2)
        {
            

            var ratio = (max2 - min2) / (max1 - min1);  //determine distance between open and close
            var c = min2 - ratio * min1;
            if((ratio * inVal + c) < 0) {
                return OverallIntensity.val * ((ratio * inVal + c) * (ratio * inVal + c) * -1f )  ;
            } 
            else
            {
                return OverallIntensity.val * ((ratio * inVal + c) * (ratio * inVal + c) * 1f) ; 
            }

        }

        public override void Init()
        {
            try
            {
                if (containingAtom.type != "Person")
                {
                    SuperController.LogError($"Plugin for use with 'Person' atom, not '{containingAtom.type}'");
                    return;
                }
                pluginLabelJSON.val = "AutoGenitalsMinora v1.0 - emAySee";
                JSONStorable js = containingAtom.GetStorableByID("geometry");
                if (js != null)
                {
                    DAZCharacterSelector dcs = js as DAZCharacterSelector;
                    GenerateDAZMorphsControlUI morphUI = dcs.morphsControlUI;
                    if (morphUI != null)
                    {
                        //
                        AWW_VagInternal_Size2 = morphUI.GetMorphByDisplayName("AWW_VagInternal_Size2");
                        if (AWW_VagInternal_Size2 == null)
                        {
                            SuperController.LogError("Couldn't find morph 'AWW_VagInternal_Size2'");
                            return;
                        }

                        AWW_Clitoris_Size = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.1:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_Size.vmi");
                        if (AWW_Clitoris_Size == null)
                        {
                            SuperController.LogError("Couldn't find morph ' AWW_Clitoris_Size'");
                            return;
                        }
                        AWW_Clitoris_HoodSize = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.1:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_HoodSize.vmi");
                        if (AWW_Clitoris_HoodSize == null)
                                          {
                            SuperController.LogError("Couldn't find morph ' AWW_Clitoris_HoodBack'");
                            return;
                        }

                        AWW_Clitoris_HoodBack = morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.1:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_HoodBack.vmi");
                        if (AWW_Clitoris_HoodBack == null)
                        {
                            SuperController.LogError("Couldn't find morph ' AWW_Clitoris_HoodBack'");
                            return;
                        }
                        AWW_Clitoris_Front_Back =morphUI.GetMorphByUid("AWWalker.AWW_GenMorphResources.1:/Custom/Atom/Person/Morphs/female_genitalia/data/3feetwolf/New Genitalia For Victoria 6/Genitalia-default/Morphs/AWWALKER/AWWalker_GEN_Morphs1.0/AWW_Clitoris_Front_Back.vmi");
                        if (AWW_Clitoris_Front_Back == null)
                        {
                            SuperController.LogError("Couldn't find morph ' AWW_Clitoris_Front_Back'");
                            return;
                        }

                        AWW_Majora_LeftUpperTopMorph = morphUI.GetMorphByDisplayName("AWW_Majora_LeftUpperTop");
                        if (AWW_Majora_LeftUpperTopMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'AWW_Majora_LeftUpperTop'");
                            return;
                        }

                        AWW_Majora_RightUpperTopMorph = morphUI.GetMorphByDisplayName("AWW_Majora_RightUpperTop");
                        if (AWW_Majora_RightUpperTopMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'AWW_Majora_RightUpperTop'");
                            return;
                        }

                        labiaMinoraMorph = morphUI.GetMorphByDisplayName("Labia minora-size");
                        if (labiaMinoraMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-size'");
                            return;
                        }

                        HoodModMorph = morphUI.GetMorphByDisplayName("HoodMod");
                        if (HoodModMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'HoodMod'");
                            return;
                        }

                        labiaMajoraMorph = morphUI.GetMorphByDisplayName("Labia majora-relaxation");
                        if (labiaMajoraMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-relaxation'");
                            return;
                        }

                        LabMajRMidMorph = morphUI.GetMorphByDisplayName("Labia majora-spread-RMid");
                        if (LabMajRMidMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-RMid'");
                            return;
                        }

                        LabMajLUpMorph = morphUI.GetMorphByDisplayName("Labia majora-spread-LUp");
                        if (LabMajLUpMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-LUp'");
                            return;
                        }

                        LabMajLMidMorph = morphUI.GetMorphByDisplayName("Labia majora-spread-LMid");
                        if (LabMajLMidMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-LMid'");
                            return;
                        }

                        LabMajLLowMorph = morphUI.GetMorphByDisplayName("Labia majora-spread-LLow");
                        if (LabMajLLowMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-LLow'");
                            return;
                        }

                        LabMinRMidMorph = morphUI.GetMorphByDisplayName("Labia minora-spread-RMid");
                        if (LabMinRMidMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-RMid'");
                            return;
                        }

                        LabMinRUpMorph = morphUI.GetMorphByDisplayName("Labia minora-spread-RUp");
                        if (LabMinRUpMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-RUp'");
                            return;
                        }

                        LabMinLLowMorph = morphUI.GetMorphByDisplayName("Labia minora-spread-LLow");
                        if (LabMinLLowMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-LLow'");
                            return;
                        }

                        LabMinLUpMorph = morphUI.GetMorphByDisplayName("Labia minora-spread-LUp");
                        if (LabMinLUpMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-LUp'");
                            return;
                        }

                        LabMajRLowMorph = morphUI.GetMorphByDisplayName("Labia majora-spread-RLow");
                        if (LabMajRLowMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-RLow'");
                            return;
                        }

                        LabMinRLowMorph = morphUI.GetMorphByDisplayName("Labia minora-spread-RLow");
                        if (LabMinRLowMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-RLow'");
                            return;
                        }

                        LabMajRUpMorph = morphUI.GetMorphByDisplayName("Labia majora-spread-RUp");
                        if (LabMajRUpMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia majora-spread-RUp'");
                            return;
                        }

                        LabMinLMidMorph = morphUI.GetMorphByDisplayName("Labia minora-spread-LMid");
                        if (LabMinLMidMorph == null)
                        {
                            SuperController.LogError("Couldn't find morph 'Labia minora-spread-LMid'");
                            return;
                        }

                    }
                }
                chest = containingAtom.GetStorableByID("chestControl") as FreeControllerV3;
                lKnee = containingAtom.GetStorableByID("lKneeControl") as FreeControllerV3;
                rKnee = containingAtom.GetStorableByID("rKneeControl") as FreeControllerV3;

                OverallIntensity = new JSONStorableFloat("Intensity", 1f,0f,2f, false, true);
                OverallIntensity.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(OverallIntensity);
                AWW_Clitoris_HoodSizeMax = new JSONStorableFloat("AWW Hood Size", 0f, -1f, 1f, false, true);
                AWW_Clitoris_HoodSizeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Clitoris_HoodSizeMax);
                
                AWW_Clitoris_SizeMax = new JSONStorableFloat("AWW Clitoris Size", 0f, -1f, 1f, false, true);
                AWW_Clitoris_SizeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Clitoris_SizeMax);

                AWW_Clitoris_HoodBackMax = new JSONStorableFloat("Hood Back/Forward", 0f, -1f, 1f, false, true);
                AWW_Clitoris_HoodBackMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Clitoris_HoodBackMax);


                AWW_Clitoris_Front_BackMin = new JSONStorableFloat("AWW Clitoris Front_Back", 0f, lmin => AWW_Clitoris_Front_BackMax.SetVal(Mathf.Max(AWW_Clitoris_Front_BackMax.val, lmin)), 0f, 1f, false, true);
                AWW_Clitoris_Front_BackMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Clitoris_Front_BackMin);

                AWW_Clitoris_Front_BackMax = new JSONStorableFloat("AWW Clitoris Front_Back", 0f, lmin => AWW_Clitoris_Front_BackMax.SetVal(Mathf.Max(AWW_Clitoris_Front_BackMax.val, lmin)), 0f, 1f, false, true);
                AWW_Clitoris_Front_BackMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Clitoris_Front_BackMax);


                AWW_VagInternal_Size2ChangeMin = new JSONStorableFloat("AWW_VagInternal_Size Min", 0f, lmin => AWW_VagInternal_Size2ChangeMax.SetVal(Mathf.Max(AWW_VagInternal_Size2ChangeMax.val, lmin)), 0f, 1f, false, true);
                AWW_VagInternal_Size2ChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_VagInternal_Size2ChangeMin);

                AWW_VagInternal_Size2ChangeMax = new JSONStorableFloat("AWW_VagInternal_Size Max", 1f, lmax => AWW_VagInternal_Size2ChangeMin.SetVal(Mathf.Min(AWW_VagInternal_Size2ChangeMin.val, lmax)), 0f, 1f, false, true);
                AWW_VagInternal_Size2ChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_VagInternal_Size2ChangeMax);






                HoodModMorphChangeMin = new JSONStorableFloat("Labia HoodMod Min", 0.75f, lmin => HoodModMorphChangeMax.SetVal(Mathf.Max(HoodModMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                HoodModMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(HoodModMorphChangeMin);

                HoodModMorphChangeMax = new JSONStorableFloat("Labia HoodMod Max", 1.7f, lmax => HoodModMorphChangeMin.SetVal(Mathf.Min(HoodModMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                HoodModMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(HoodModMorphChangeMax);

                labiaMajoraMorphChangeMin = new JSONStorableFloat("Labia Majora Morph Min", -1.21f, lmin => labiaMajoraMorphChangeMax.SetVal(Mathf.Max(labiaMajoraMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                labiaMajoraMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(labiaMajoraMorphChangeMin);

                labiaMajoraMorphChangeMax = new JSONStorableFloat("Labia Majora Morph Max", 2f, lmax => labiaMajoraMorphChangeMin.SetVal(Mathf.Min(labiaMajoraMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                labiaMajoraMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(labiaMajoraMorphChangeMax);

                AWW_Majora_LeftUpperTopMorphChangeMin = new JSONStorableFloat("Left Top Morph Min", -0.4f, lmin => AWW_Majora_LeftUpperTopMorphChangeMax.SetVal(Mathf.Max(AWW_Majora_LeftUpperTopMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                AWW_Majora_LeftUpperTopMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Majora_LeftUpperTopMorphChangeMin);

                AWW_Majora_LeftUpperTopMorphChangeMax = new JSONStorableFloat("Left Top Morph Max", 0.9f, lmax => AWW_Majora_LeftUpperTopMorphChangeMin.SetVal(Mathf.Min(AWW_Majora_LeftUpperTopMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                AWW_Majora_LeftUpperTopMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Majora_LeftUpperTopMorphChangeMax);

                AWW_Majora_RightUpperTopMorphChangeMin = new JSONStorableFloat("Right Top Morph Min", -0.4f, lmin => AWW_Majora_RightUpperTopMorphChangeMax.SetVal(Mathf.Max(AWW_Majora_RightUpperTopMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                AWW_Majora_RightUpperTopMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Majora_RightUpperTopMorphChangeMin);

                AWW_Majora_RightUpperTopMorphChangeMax = new JSONStorableFloat("Right Top Morph Max", 0.9f, lmax => AWW_Majora_RightUpperTopMorphChangeMin.SetVal(Mathf.Min(AWW_Majora_RightUpperTopMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                AWW_Majora_RightUpperTopMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(AWW_Majora_RightUpperTopMorphChangeMax);

                LabMajLUpMorphChangeMin = new JSONStorableFloat("Labia LabMajLUp Min", -0.45f, lmin => LabMajLUpMorphChangeMax.SetVal(Mathf.Max(LabMajLUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajLUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLUpMorphChangeMin);

                LabMajLUpMorphChangeMax = new JSONStorableFloat("Labia LabMajLUp Max", 0.35f, lmax => LabMajLUpMorphChangeMin.SetVal(Mathf.Min(LabMajLUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajLUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLUpMorphChangeMax);


                LabMajRUpMorphChangeMin = new JSONStorableFloat("Labia LabMajRUp Min", -0.45f, lmin => LabMajRUpMorphChangeMax.SetVal(Mathf.Max(LabMajRUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajRUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRUpMorphChangeMin);

                LabMajRUpMorphChangeMax = new JSONStorableFloat("Labia LabMajRUp Max", 0.35f, lmax => LabMajRUpMorphChangeMin.SetVal(Mathf.Min(LabMajRUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajRUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRUpMorphChangeMax);

                LabMajLMidMorphChangeMin = new JSONStorableFloat("Labia LabMajLMid Min", 0.25f, lmin => LabMajLMidMorphChangeMax.SetVal(Mathf.Max(LabMajLMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajLMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLMidMorphChangeMin);

                LabMajLMidMorphChangeMax = new JSONStorableFloat("Labia LabMajLMid Max", 0.4f, lmax => LabMajLMidMorphChangeMin.SetVal(Mathf.Min(LabMajLMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajLMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLMidMorphChangeMax);

                LabMajRMidMorphChangeMin = new JSONStorableFloat("Labia LabMajRMid Min", 0.25f, lmin => LabMajRMidMorphChangeMax.SetVal(Mathf.Max(LabMajRMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajRMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRMidMorphChangeMin);

                LabMajRMidMorphChangeMax = new JSONStorableFloat("Labia LabMajRMid Max", 0.4f, lmax => LabMajRMidMorphChangeMin.SetVal(Mathf.Min(LabMajRMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajRMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRMidMorphChangeMax);

                LabMajLLowMorphChangeMin = new JSONStorableFloat("Labia LabMajLLow Min", 0.25f, lmin => LabMajLLowMorphChangeMax.SetVal(Mathf.Max(LabMajLLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajLLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLLowMorphChangeMin);

                LabMajLLowMorphChangeMax = new JSONStorableFloat("Labia LabMajLLow Max", 0.65f, lmax => LabMajLLowMorphChangeMin.SetVal(Mathf.Min(LabMajLLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajLLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajLLowMorphChangeMax);

                LabMajRLowMorphChangeMin = new JSONStorableFloat("Labia LabMajRLow Min", 0.25f, lmin => LabMajRLowMorphChangeMax.SetVal(Mathf.Max(LabMajRLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMajRLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRLowMorphChangeMin);

                LabMajRLowMorphChangeMax = new JSONStorableFloat("Labia LabMajRLow Max", 0.65f, lmax => LabMajRLowMorphChangeMin.SetVal(Mathf.Min(LabMajRLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMajRLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMajRLowMorphChangeMax);

                //Minora 

                labiaMinoraMorphChangeMin = new JSONStorableFloat("Labia Minora Morph Min", -0.7f, lmin => labiaMinoraMorphChangeMax.SetVal(Mathf.Max(labiaMinoraMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                labiaMinoraMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(labiaMinoraMorphChangeMin);

                labiaMinoraMorphChangeMax = new JSONStorableFloat("Labia Minora Morph Max", 1f, lmax => labiaMinoraMorphChangeMin.SetVal(Mathf.Min(labiaMinoraMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                labiaMinoraMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(labiaMinoraMorphChangeMax);

                LabMinLUpMorphChangeMin = new JSONStorableFloat("Labia LabMinLUp Min", -0.25f, lmin => LabMinLUpMorphChangeMax.SetVal(Mathf.Max(LabMinLUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinLUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLUpMorphChangeMin);

                LabMinLUpMorphChangeMax = new JSONStorableFloat("Labia LabMinLUp Max", 0.8f, lmax => LabMinLUpMorphChangeMin.SetVal(Mathf.Min(LabMinLUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinLUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLUpMorphChangeMax);


                LabMinRUpMorphChangeMin = new JSONStorableFloat("Labia LabMinRUp Min", -0.25f, lmin => LabMinRUpMorphChangeMax.SetVal(Mathf.Max(LabMinRUpMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinRUpMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRUpMorphChangeMin);

                LabMinRUpMorphChangeMax = new JSONStorableFloat("Labia LabMinRUp Max", 0.8f, lmax => LabMinRUpMorphChangeMin.SetVal(Mathf.Min(LabMinRUpMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinRUpMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRUpMorphChangeMax);

                LabMinLMidMorphChangeMin = new JSONStorableFloat("Labia LabMinLMid Min", -0.1f, lmin => LabMinLMidMorphChangeMax.SetVal(Mathf.Max(LabMinLMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinLMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLMidMorphChangeMin);

                LabMinLMidMorphChangeMax = new JSONStorableFloat("Labia LabMinLMid Max", 0.50f, lmax => LabMinLMidMorphChangeMin.SetVal(Mathf.Min(LabMinLMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinLMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLMidMorphChangeMax);

                LabMinRMidMorphChangeMin = new JSONStorableFloat("Labia LabMinRMid Min", -0.1f, lmin => LabMinRMidMorphChangeMax.SetVal(Mathf.Max(LabMinRMidMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinRMidMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRMidMorphChangeMin);

                LabMinRMidMorphChangeMax = new JSONStorableFloat("Labia LabMinRMid Max", 0.50f, lmax => LabMinRMidMorphChangeMin.SetVal(Mathf.Min(LabMinRMidMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinRMidMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRMidMorphChangeMax);

 
                LabMinLLowMorphChangeMin = new JSONStorableFloat("Labia LabMinLLow Min", 0f, lmin => LabMinLLowMorphChangeMax.SetVal(Mathf.Max(LabMinLLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinLLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLLowMorphChangeMin);

              LabMinRLowMorphChangeMax = new JSONStorableFloat("Labia LabMinRLow Max", 0.75f, lmax => LabMinRLowMorphChangeMin.SetVal(Mathf.Min(LabMinRLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinRLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRLowMorphChangeMax);

                LabMinRLowMorphChangeMin = new JSONStorableFloat("Labia LabMinRLow Min", 0f, lmin => LabMinRLowMorphChangeMax.SetVal(Mathf.Max(LabMinRLowMorphChangeMax.val, lmin)), -1f, 1f, false, true);
                LabMinRLowMorphChangeMin.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinRLowMorphChangeMin);

                LabMinLLowMorphChangeMax = new JSONStorableFloat("Labia LabMinLLow Max", 0.75f, lmax => LabMinLLowMorphChangeMin.SetVal(Mathf.Min(LabMinLLowMorphChangeMin.val, lmax)), 0f, 1f, false, true);
                LabMinLLowMorphChangeMax.storeType = JSONStorableParam.StoreType.Full;
                RegisterFloat(LabMinLLowMorphChangeMax);




                //Create UI

                //var loadSettings = CreateButton("Load Settings", true);
                //var saveSettings = CreateButton("Save Settings", false);
                //saveSettings.button.onClick.AddListener(gacSaveSettings);
                //loadSettings.button.onClick.AddListener(gacLoadSettings);
                string txtTitle = "Genital Multi-Pass\nby: AWWalker\nCredit to: VeeRifter for the idea\nVersion: 2.0";
                string txtDesc = "Set min and max sliders to your liking, great for animations, or adjusting still poses on the fly! (Save plugin Preset to keep settings for now)";

                JSONStorableString strTitle = new JSONStorableString("Title", txtTitle);
                UIDynamicTextField textfieldtitl = CreateTextField(strTitle, rightSide);
                JSONStorableString strDescription = new JSONStorableString("Description", txtDesc);
                UIDynamicTextField textfielddesc = CreateTextField(strDescription, leftSide);

                CreateButton("Static", true);
                CreateButton(" ", false);
                CreateSlider(AWW_Clitoris_HoodBackMax, false);
                CreateSlider(AWW_Clitoris_Front_BackMax, true);
                CreateSlider(AWW_Clitoris_SizeMax, false);
                CreateSlider(AWW_Clitoris_HoodSizeMax, true);
                createSPACER(25);

                CreateButton("Intensity", true);
                CreateButton(" ", true);
                CreateSlider(OverallIntensity, false);
                // Hood
                createSPACER(25);

                CreateButton("Centered Morphs Min", true);
                CreateButton("Centered Morphs Max", false);

                CreateSlider(HoodModMorphChangeMin, false);
                CreateSlider(HoodModMorphChangeMax, true);

                CreateSlider(AWW_VagInternal_Size2ChangeMin, false);
                CreateSlider(AWW_VagInternal_Size2ChangeMax, true);





                // Majora
                createSPACER(25);

                CreateButton("Labia Majora Max", true);
                CreateButton("Labia Majora Min", false);


                CreateSlider(labiaMajoraMorphChangeMin, false);
                CreateSlider(labiaMajoraMorphChangeMax, true);

                CreateSlider(AWW_Majora_RightUpperTopMorphChangeMin, false);
                CreateSlider(AWW_Majora_RightUpperTopMorphChangeMax, true);

                CreateSlider(AWW_Majora_LeftUpperTopMorphChangeMin, false);
                CreateSlider(AWW_Majora_LeftUpperTopMorphChangeMax, true);

                CreateSlider(LabMajRUpMorphChangeMin, false);
                CreateSlider(LabMajRUpMorphChangeMax, true);

                CreateSlider(LabMajLUpMorphChangeMin, false);
                CreateSlider(LabMajLUpMorphChangeMax, true);

                CreateSlider(LabMajRMidMorphChangeMin, false);
                CreateSlider(LabMajRMidMorphChangeMax, true);

                CreateSlider(LabMajLMidMorphChangeMin, false);
                CreateSlider(LabMajLMidMorphChangeMax, true);

                CreateSlider(LabMajRLowMorphChangeMin, false);
                CreateSlider(LabMajRLowMorphChangeMax, true);

                CreateSlider(LabMajLLowMorphChangeMin, false);
                CreateSlider(LabMajLLowMorphChangeMax, true);


                // Minora
                createSPACER(25);

                CreateButton("Labia Minora Max", true);
                CreateButton("Labia Minora Min", false);

                
                CreateSlider(labiaMinoraMorphChangeMin, false);
                CreateSlider(labiaMinoraMorphChangeMax, true);

                CreateSlider(LabMinRUpMorphChangeMin, false);
                CreateSlider(LabMinRUpMorphChangeMax, true);

                CreateSlider(LabMinLUpMorphChangeMin, false);
                CreateSlider(LabMinLUpMorphChangeMax, true);

                CreateSlider(LabMinRMidMorphChangeMin, false);
                CreateSlider(LabMinRMidMorphChangeMax, true);

                CreateSlider(LabMinLMidMorphChangeMin, false);
                CreateSlider(LabMinLMidMorphChangeMax, true);

                CreateSlider(LabMinRLowMorphChangeMin, false);
                CreateSlider(LabMinRLowMorphChangeMax, true);

                CreateSlider(LabMinLLowMorphChangeMin, false);
                CreateSlider(LabMinLLowMorphChangeMax, true);


                
                CreateSlider(AWW_Clitoris_Front_BackMax, true);

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        public static string GetPluginPath(MVRScript self)
        {
            string id = self.name.Substring(0, self.name.IndexOf('_'));
            string filename = self.manager.GetJSON()["plugins"][id].Value;
            return filename.Substring(0, filename.LastIndexOfAny(new char[] { '/', '\\' }));
        }

        private void gacSaveSettings()
        {
            SuperController.LogMessage("Save Settings");
            SuperController.LogMessage(GetPluginPath(this));
            SuperController.LogMessage(HoodModMorphChangeMin.val.ToString());
            SuperController.LogMessage(HoodModMorphChangeMax.val.ToString());


            SuperController.LogMessage(labiaMinoraMorphChangeMin.val.ToString());
            SuperController.LogMessage(labiaMinoraMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMinRUpMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMinRUpMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMinLUpMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMinLUpMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMinRMidMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMinRMidMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMinLMidMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMinLMidMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMinRLowMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMinRLowMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMinLLowMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMinLLowMorphChangeMax.val.ToString());

            SuperController.LogMessage(labiaMajoraMorphChangeMin.val.ToString());
            SuperController.LogMessage(labiaMajoraMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMajRUpMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMajRUpMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMajLUpMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMajLUpMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMajRMidMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMajRMidMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMajLMidMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMajLMidMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMajRLowMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMajRLowMorphChangeMax.val.ToString());

            SuperController.LogMessage(LabMajLLowMorphChangeMin.val.ToString());
            SuperController.LogMessage(LabMajLLowMorphChangeMax.val.ToString());

            MVR.FileManagementSecure.FileManagerSecure.WriteAllText($"{GetPluginPath(this)}/GenitalSpreadController.Data.json", "Test");


        }


    
            private void gacLoadSettings()
        {
            SuperController.LogMessage("Load Settings");
        }

        public void Update()
        {
            Vector3 chestPos = chest.followWhenOff.position;
            Vector3 lKneePos = lKnee.followWhenOff.position;
            Vector3 rKneePos = rKnee.followWhenOff.position;
            Vector3 direction = lKneePos - rKneePos;
            float rKneeTolKnee = direction.magnitude;
            direction = lKneePos - chestPos;
            float lKneeToChest = direction.magnitude;
            direction = rKneePos - chestPos;
            float rKneeToChest = direction.magnitude;
            float spread = rKneeTolKnee - (Mathf.Abs(lKneeToChest - rKneeToChest) * 2);

            try { HoodModMorph.morphValue = Remap(spread, 0, 1, HoodModMorphChangeMin.val, HoodModMorphChangeMax.val); } catch { }
            try { labiaMajoraMorph.morphValue = Remap(spread, 0, 1, labiaMajoraMorphChangeMin.val, labiaMajoraMorphChangeMax.val); } catch { }
            try { LabMajRMidMorph.morphValue = Remap(spread, 0, 1, LabMajRMidMorphChangeMin.val, LabMajRMidMorphChangeMax.val); } catch { }
            try { LabMajLUpMorph.morphValue = Remap(spread, 0, 1, LabMajLUpMorphChangeMin.val, LabMajLUpMorphChangeMax.val); } catch { }
            try { LabMajLMidMorph.morphValue = Remap(spread, 0, 1, LabMajLMidMorphChangeMin.val, LabMajLMidMorphChangeMax.val); } catch { }
            try { LabMajLLowMorph.morphValue = Remap(spread, 0, 1, LabMajLLowMorphChangeMin.val, LabMajLLowMorphChangeMax.val); } catch { }
            try { LabMajRLowMorph.morphValue = Remap(spread, 0, 1, LabMajRLowMorphChangeMin.val, LabMajRLowMorphChangeMax.val); } catch { }
            try { LabMajRUpMorph.morphValue = Remap(spread, 0, 1, LabMajRUpMorphChangeMin.val, LabMajRUpMorphChangeMax.val); } catch { }
            try { labiaMinoraMorph.morphValue = Remap(spread, 0, 1, labiaMinoraMorphChangeMin.val, labiaMinoraMorphChangeMax.val); } catch { }
            // Negatives below fix the movent direction of the morph

                try { AWW_Majora_LeftUpperTopMorph.morphValue = Remap(-spread, 0, 1, -AWW_Majora_LeftUpperTopMorphChangeMin.val, AWW_Majora_LeftUpperTopMorphChangeMax.val); } catch { }
                try { AWW_Majora_RightUpperTopMorph.morphValue = Remap(-spread, 0, 1, -AWW_Majora_RightUpperTopMorphChangeMin.val, AWW_Majora_RightUpperTopMorphChangeMax.val);

                try { LabMinRUpMorph.morphValue = Remap(spread, 0, 1, LabMinRUpMorphChangeMin.val, LabMinRUpMorphChangeMax.val); } catch { }
                try { LabMinLUpMorph.morphValue = Remap(spread, 0, 1, LabMinLUpMorphChangeMin.val, LabMinLUpMorphChangeMax.val); } catch { }
                try { LabMinRMidMorph.morphValue = Remap(spread, 0, 1, LabMinRMidMorphChangeMin.val, LabMinRMidMorphChangeMax.val); } catch { }
                try { LabMinLMidMorph.morphValue = Remap(spread, 0, 1, LabMinLMidMorphChangeMin.val, LabMinLMidMorphChangeMax.val); } catch { }
                try { LabMinRLowMorph.morphValue = Remap(-spread, 0, 1, LabMinRLowMorphChangeMin.val, -LabMinRLowMorphChangeMax.val); } catch { }
                try { LabMinLLowMorph.morphValue = Remap(-spread, 0, 1, LabMinLLowMorphChangeMin.val, -LabMinLLowMorphChangeMax.val); } catch { }


                try { AWW_VagInternal_Size2.morphValue = Remap(spread, 0, 1, AWW_VagInternal_Size2ChangeMin.val, AWW_VagInternal_Size2ChangeMax.val); } catch { }

                try{ AWW_Clitoris_Front_Back.morphValue = Remap(1, 0, 1, AWW_Clitoris_Front_BackMax.val, AWW_Clitoris_Front_BackMax.val); }
                catch { }

                try { AWW_Clitoris_HoodBack.morphValue = Remap(1, 0, 1, AWW_Clitoris_HoodBackMax.val, AWW_Clitoris_HoodBackMax.val); }
                catch { }

                try { AWW_Clitoris_Size.morphValue = Remap(1, 0, 1, AWW_Clitoris_SizeMax.val, AWW_Clitoris_SizeMax.val); }
                catch { }

                try { AWW_Clitoris_HoodSize.morphValue = Remap(1, 0, 1, AWW_Clitoris_HoodSizeMax.val, AWW_Clitoris_HoodSizeMax.val); }
                catch { }



                //All the morphs are opening morphs, except the last two by me, those were closing morphs... that's why there are so many (-) negative marks everywhere to mimic the beahiour of the rest of them

                // Debug Values here (UP to 3 -- easy to view in logMessage)
                // SuperController.LogMessage("RUT:" + AWW_Majora_RightUpperTopMorph.morphValue.ToString());
                // SuperController.LogMessage(":");
                // SuperController.LogMessage("RUP:" + LabMajRUpMorph.morphValue.ToString());





            }
            catch { }


        }
        private void createSPACER(float height)
        {

            CreateSpacer(false).height = height;
            CreateSpacer(true).height = height;


        }

    }
}

//*
//NOTES V.2
//
// ADDED OVERALL INTENSITY
//*

    